<template>
  <div id="app">
    <router-view :key="$route.fullPath"></router-view>
    <!-- <pre>{{userStore }}</pre> -->
  </div>
</template>
<script>
import Vue from "vue";
import { mapState } from "vuex";
import { BootstrapVue, BootstrapVueIcons } from "bootstrap-vue";
import CoolLightBox from "vue-cool-lightbox";
import "vue-cool-lightbox/dist/vue-cool-lightbox.min.css";
import VueCarousel from "vue-carousel";
import { authenticationService } from "./_services/authentication.service";
import Spinner from 'vue-simple-spinner';

import VueLazyLoad from "vue-lazyload";

// importation font awesome sa race !
import { library } from "@fortawesome/fontawesome-svg-core";
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { faAngleRight, faFacebook, faShoppingCart, faTrash, faEdit, faEnvelope, faTrashAlt, faLock, faUnlock, faPhoneAlt, faUndo, faSearchPlus, faShareAlt } from "@fortawesome/free-solid-svg-icons";
library.add(faAngleRight, faShoppingCart, faTrash, faEdit, faEnvelope, faTrashAlt, faLock, faUnlock, faPhoneAlt, faUndo, faSearchPlus, faShareAlt);

// import { structureDataService } from "./_services/structureData.service";
Vue.use(BootstrapVue);
Vue.use(BootstrapVueIcons);
Vue.use(CoolLightBox);
Vue.use(VueLazyLoad);

// example filter custom
// Vue.filter("reverse", function (value) {
//   return value.split("").reverse().join("");
// });

// remove html

Vue.filter("cleanHtml", function(value) {
  let regex = /(<([^>]+)>)/gi;
  return value.replace(regex, "");
});

// filtre limite caractèers
Vue.filter("str_limit", function(value, size) {
  if (size == 0 || size == "" || size == "undefined" || size == undefined) return value;
  if (!value) return "";
  value = value.toString();

  if (value.length <= size) {
    return value;
  }
  return value.substr(0, size) + "...";
});

// filtre date
var simplyDate = function(value) {
  // let v = new Date(value.toString())
  let v = new Date(value);
  let m = v.getMonth() + 1;
  let d = v.getDate();
  let a = v.getFullYear();
  return d + "/" + m + "/" + a;
};

Vue.filter("simplyDate", simplyDate);

// filtre format euro
Vue.filter("euro", function(value) {
  const euro = new Intl.NumberFormat("fr-FR", {
    style: "currency",
    currency: "EUR",
    minimumFractionDigits: 2
  });
  return euro.format(value);

  // return value.split("").reverse().join("");
});
Vue.use(VueCarousel);

Vue.component("font-awesome-icon", FontAwesomeIcon);
Vue.component("vue-simple-spinner",Spinner);

export default {
  computed: {
    ...mapState({
      userStore: state => state.userStore,
      cartStore: state => state.cartStore,
      clientStore: state => state.clientStore
    })
  },
  created() {
    // récupération des infos utilisateur admin
    const userObj = JSON.parse(window.localStorage.getItem("authUser"));
    this.$store.dispatch("setUserObject", userObj);
    authenticationService.checkRoles();
  }
};
</script>
